import * as esbuild from 'esbuild'
import cc from '@apeleghq/esbuild-plugin-closure-compiler'

const closure = cc({ language_in: 'UNSTABLE', compilation_level: 'SIMPLE' })

const cjs = esbuild.build({
    entryPoints: ['src/index.ts'],
    bundle: true,
    format: 'cjs',
    sourcemap: 'linked',
    outfile: './dist/index.js',
})

const cjsmin = esbuild.build({
    entryPoints: ['src/index.ts'],
    bundle: true,
    outfile: './dist/index.min.js',
    format: 'cjs',
    sourcemap: 'linked',
    plugins: [closure]
})

const esm = esbuild.build({
    entryPoints: ['src/index.ts'],
    bundle: true,
    format: 'esm',
    sourcemap: 'linked',
    outfile: './dist/index.esm.js'
})

const esmmin = esbuild.build({
    entryPoints: ['src/index.ts'],
    bundle: true,
    format: 'esm',
    sourcemap: 'linked',
    outfile: './dist/index.esm.min.js',
    plugins: [closure]
})

await Promise.all([cjs, cjsmin, esm, esmmin])

